; 

    .486                        ; create 32 bit code
    .model flat, stdcall        ; 32 bit memory model
    option casemap :none        ; case sensitive

    include TrakLog.inc         ; local includes for this file

    RichEdMl PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

  .data?
    hEdit dd ?
    interval dd ?
    hTimer dd ?
    filelen dd ?
    logbuffer db 260 dup (?)

.code

start:

; 

      invoke InitCommonControls

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   FUNC(GetModuleHandle, NULL)
      mov CommandLine, FUNC(GetCommandLine)
      mov hIcon,       FUNC(LoadIcon,hInstance,500)
      mov hCursor,     FUNC(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        FUNC(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        FUNC(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"log_track_class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 75, 70

    invoke CreateWindowEx,WS_EX_LEFT or WS_EX_ACCEPTFILES,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayMenu hWnd,600
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp jumpin

    StartLoop:
      invoke TranslateMessage, esi
    ; --------------------------------------
    ; perform any required key processing here
    ; --------------------------------------
      invoke DispatchMessage,  esi
    jumpin:
      invoke GetMessage,esi,edi,edi,edi
      test eax, eax
      jnz StartLoop

    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL fname  :DWORD
    LOCAL patn   :DWORD
    LOCAL sbh    :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[260]:BYTE  ; these are two spare buffers
    LOCAL buffer2[260]:BYTE  ; for text manipulation etc..
    LOCAL pbuf  :DWORD
    LOCAL hFile :DWORD
    LOCAL hMem  :DWORD
    LOCAL bWritten  :DWORD
    LOCAL cloc  :DWORD
    LOCAL cr    :CHARRANGE
    LOCAL flen2 :DWORD

    Switch uMsg
      Case WM_COMMAND

        Switch wParam
        ;======== menu commands ========

          Case 1001
            sas patn, "All files",0,"*.*",0
            mov fname, OpenFileDlg(hWin,hInstance,"Select File To Track",patn)
            cmp BYTE PTR [eax], 0
            jne @F
            return 0
            @@:

            invoke szCopy,fname,OFFSET logbuffer
            invoke SendMessage,hStatus,SB_SETTEXT,3,OFFSET logbuffer

            mov filelen, rv(filesize,OFFSET logbuffer)
            fn SendMessage,hStatus,SB_SETTEXT,1,str$(filelen)

            fn SendMessage,hStatus,SB_SETTEXT,2,"Tracking"

            .if hFile != 0
              fclose hFile
            .endif

            invoke CreateFile,OFFSET logbuffer,GENERIC_READ,FILE_SHARE_WRITE,
                              NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
            mov hFile, eax

          .if filelen < 4096
            mov hMem, alloc(filelen)
            mov bWritten, fread(hFile,hMem,filelen)
            invoke SetWindowText,hEdit,hMem
            invoke GetWindowTextLength,hEdit
            mov cr.cpMin, eax
            mov cr.cpMax, eax
            invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr
            free hMem
          .else
            mov hMem, alloc(4096)
            invoke SetFilePointer,hFile,-4095,0,FILE_END
            mov bWritten, fread(hFile,hMem,4096)
            invoke SetWindowText,hEdit,hMem
            invoke GetWindowTextLength,hEdit
            mov cr.cpMin, eax
            mov cr.cpMax, eax
            invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr
            free hMem
          .endif

          fclose hFile

          Case 1002
            fn MessageBox,hWin,"Function not written yet","Sorry ...",MB_OK

          Case 1010
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

          Case 1900
            ShellAboutBox hWin,hIcon,\
              "About Log File Tracker#Windows Log File Tracker",\
              "Log File Tracker",13,10,"Copyright  MASM32 1998-2006"

          ;====== end menu commands ======
      Endsw

      Case WM_DROPFILES
        mov fname, DropFileName(wParam)
        fn MessageBox,hWin,fname,"WM_DROPFILES",MB_OK

      Case WM_TIMER
        mov pbuf, ptr$(buffer1)
        invoke GetTimeFormat,LOCALE_USER_DEFAULT,NULL,NULL,NULL,pbuf,260
        invoke SendMessage,hStatus,SB_SETTEXT,0,pbuf

        invoke filesize,OFFSET logbuffer

        .if filelen != eax
          mov filelen, eax
          mov flen2, eax
          add flen2, 1
          fn SendMessage,hStatus,SB_SETTEXT,1,str$(flen2)
          mov eax, OFFSET logbuffer
          cmp BYTE PTR [eax], 0
          je nofile

            invoke CreateFile,OFFSET logbuffer,GENERIC_READ,FILE_SHARE_WRITE,
                              NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
            mov hFile, eax

          .if flen2 < 4096
            mov hMem, alloc(flen2)
            mov bWritten, fread(hFile,hMem,flen2)
            invoke SetWindowText,hEdit,hMem
            invoke GetWindowTextLength,hEdit
            mov cr.cpMin, eax
            mov cr.cpMax, eax
            invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr
            free hMem
          .else
            mov hMem, alloc(4096)
            invoke SetFilePointer,hFile,-4095,0,FILE_END
            mov bWritten, fread(hFile,hMem,4096)
            invoke SetWindowText,hEdit,hMem
            invoke GetWindowTextLength,hEdit
            mov cr.cpMin, eax
            mov cr.cpMax, eax
            invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR cr
            free hMem
          .endif

          fclose hFile

        .endif

        nofile:

      Case WM_CREATE
        mov hFile, 0
        mov interval, 1000
        mov hTimer, rv(SetTimer,hWin,9999,interval,NULL)

        szText ReDLL,"RICHED32.DLL"
        invoke LoadLibrary,ADDR ReDLL
        invoke RichEdMl,200,90,250,200,hWin,800
        mov hEdit, eax
        invoke GetStockObject,SYSTEM_FIXED_FONT
        invoke SendMessage,hEdit,WM_SETFONT,eax,0
        invoke SendMessage,hEdit,EM_EXLIMITTEXT,0,4000000

        invoke Do_Status,hWin

        mov logbuffer[0], 0

      Case WM_SYSCOLORCHANGE

      Case WM_SIZE
        invoke MoveWindow,hStatus,0,0,0,0,TRUE
        invoke GetClientRect,hStatus,ADDR Rct
        mov eax, Rct.bottom
        mov sbh, eax
        invoke GetClientRect,hWin,ADDR Rct
        mov eax, sbh
        sub Rct.bottom, eax
        invoke MoveWindow,hEdit,0,0,Rct.right,Rct.bottom,TRUE

      Case WM_PAINT
        invoke Paint_Proc,hWin
        return 0

      Case WM_CLOSE
        invoke KillTimer,hWin,hTimer
        fclose hFile


      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

Paint_Proc proc hWin:DWORD

    LOCAL hDC      :DWORD
    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT
    LOCAL Ps       :PAINTSTRUCT

    mov hDC, rv(BeginPaint,hWin,ADDR Ps)

  ; ----------------------------------------

    mov btn_hi, rv(GetSysColor,COLOR_BTNHIGHLIGHT)

    mov btn_lo, rv(GetSysColor,COLOR_BTNSHADOW)

  ; ----------------------------------------

    invoke EndPaint,hWin,ADDR Ps

    ret

Paint_Proc endp

; 

RichEdMl proc a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,hParent:DWORD,ID:DWORD

    fn CreateWindowEx,WS_EX_STATICEDGE,"RICHEDIT",0, \
                      WS_VISIBLE or WS_CHILDWINDOW or \
                      ES_MULTILINE or WS_VSCROLL or WS_HSCROLL or \
                      ES_AUTOHSCROLL or ES_AUTOVSCROLL or ES_NOHIDESEL, \
                      a,b,wd,ht,hParent,ID,hInstance,NULL

    ret

RichEdMl endp

; 

end start
